/*************************************************************************/
/*************************************************************************/
/*                                                                       */
/*  File Name : VRPGAOperation.h                                         */
/*                                                                       */
/*       Date : June 16, 1999                                            */
/* Updated at : June 16, 1999                                            */
/*                                                                       */
/*     Author : H. Timucin OZDEMIR                                       */
/*                                                                       */
/*************************************************************************/
/*  
   GA operator for Vehicle Routing Problem
*/
/*************************************************************************/

#ifndef _VRPGAOperation_h
#define _VRPGAOperation_h

#include <MutationOperator.h>
#include <Chromosomes.h>
#include "VRPChromosomes.h"

class VRPGAOperation  {
  public:

   VRPGAOperation() { myDebug=0; }

  protected:

   find1PX(ListOfEdgeLists*,ListOfEdgeLists*,ListOfEdgeLists**,VRProblemPtr);
   find1PX(ListOfEdgeLists*,int,ListOfEdgeLists*,int,int&,int&,ListOfEdgeLists**,VRProblemPtr);
   find1PXG( ListOfEdgeLists*,ListOfEdgeLists*,ListOfEdgeLists**,
	     VRProblemPtr,int,int fakeGreedy=0);

   find1PX( EdgeListPtr,int ,EdgeListPtr,int ,int& ,int&,VRProblemPtr );

   find1PX( EdgeListPtr, int, EdgeListPtr, int, int&, int&,
	    EdgeListPtr*, VRProblemPtr );

   find1PXG( EdgeListPtr edLst1, int fIndex, EdgeListPtr edLst2, int sIndex,
             int& rfIndex, int& rsIndex, EdgeListPtr* ret, 
             int greedy, VRProblem* prob, int fakeGreedy=0);

   find2PX(ListOfEdgeLists*,ListOfEdgeLists*,ListOfEdgeLists**,VRProblemPtr);

   find2PX(EdgeListPtr,EdgeListPtr,int& ,int&,int&,int&,VRProblemPtr );

   find2PX( EdgeListPtr , int , EdgeListPtr , int , int& , int& , int& , int& ,
            VRProblemPtr , EdgeListPtr* );

   find2PXG(EdgeListPtr,EdgeListPtr,int& ,int&,int&,int&,VRProblemPtr,
	    int,int fakeGreedy=0);

   find2PXG( EdgeListPtr,EdgeListPtr,int& ,int&,int&,int&,VRProblemPtr,int,
	     EdgeListPtr*, int fakeGreedy=0);

   find2PX(EdgeListPtr,int,EdgeListPtr,int,int& ,int&,int&,int&,VRProblemPtr );

   satisfies2PX( VRPSolution *child, ListOfEdgeLists *el, 
	         ListOfEdgeLists *re, ListOfEdgeLists** ret) ;

   satisfies2PXG( VRPSolution *child, ListOfEdgeLists *el, ListOfEdgeLists *re,
		  ListOfEdgeLists** ret, int, int fakeGreedy=0 ) ;

   ListOfEdgeLists* 
   defineLOfELists( ListOfEdgeLists*,int , EdgeListPtr, VRProblemPtr);

   ListOfEdgeLists* 
   defineLOfELists2( ListOfEdgeLists*,int , EdgeListPtr, VRProblemPtr);

   ListOfEdgeLists* 
   defineLOfELists( ListOfEdgeLists*,int, int, 
		    ListOfEdgeLists*,int, int, VRProblemPtr);

   ListOfEdgeLists* 
   defineLOfELists( ListOfEdgeLists*,int, ListOfEdgeLists*,int, VRProblemPtr);

   ListOfEdgeLists* 
   defineLOfELists( ListOfEdgeLists*,int, EdgeListPtr, 
		    ListOfEdgeLists*,int, VRProblemPtr);

   ListOfEdgeLists* 
   defineLOfELists( ListOfEdgeLists*,int, int, ListOfEdgeLists*,int, int, 
		    EdgeListPtr e1, EdgeListPtr e2, VRProblemPtr);

   EdgeListPtr defineELists(EdgeListPtr,int ,EdgeListPtr,int ,VRProblem*);

   EdgeListPtr defineELists(EdgeListPtr,int,int,EdgeListPtr,int,int,VRProblem*);

   void buildChildren( VRPChromosomes* child, VRPChromosomes* parent, 
		       ListOfEdgeLists* el);

   inline void buildChildren(VRPChromosomes* child, VRPChromosomes* parent,
 		      int n0, int n1, ListOfEdgeLists** el)
   { buildChildren((VRPSolution*)child,(VRPSolution*)parent,n0,n1,el);};

   void buildChildren(VRPSolution* child, VRPSolution* parent,
 		      int n0, int n1, ListOfEdgeLists** el);

 private:
   char myDebug;
}; // end of Class VRPGAOperation

#endif
